
<div class='main'>
  <div id='tests'>
  </div>
  <div id='term_wrap'>
    <div id='term_container'>
    </div>
  </div>
</div>

<script type='text/javascript'>

  /*
   * Test of the Session API
   */

  var sessionTests = [
    {
      name: 'echo exec',
      run: () => {
        return new Promise(async (resolve, reject) => {
          const stdout = 'Hello world!';
          const cmd = String.raw`echo -en "${stdout}\n"`;
          try {
            const sid = await LupBookVM.Session.open('test-echo');
            const res = await LupBookVM.Session.exec(sid, cmd);
            const txt =
                `cmd:     ${cmd}\n`
              + `exit:    ${res.exitCode}\n`
              + `output:  ${res.outputCmd}\n`;
              + `shell:   ${res.outputShell}\n`;
            resolve({
              pass: res.exitCode === 0 && res.outputCmd === `${stdout}\n`,
              log: txt,
            });
          } catch (err) {
            reject(err);
          }
        });
      }
    },
    {
      name: 'compilation',
      run: () => {
        return new Promise(async (resolve, reject) => {
          const stdout = 'Hello world!';
          const program = String.raw`
#include <stdio.h>
int main(int argc, char **argv) {
    printf("${stdout}\n");
    return 0;
}
          `;
          const cmd = String.raw`gcc hello.c -o hello && ./hello`;
          try {
            const sid = await LupBookVM.Session.open('test-compilation');
            await LupBookVM.Session.upload(sid, "hello.c", program);
            const res = await LupBookVM.Session.exec(sid, cmd);
            const txt =
                `cmd:     ${cmd}\n`
              + `exit:    ${res.exitCode}\n`
              + `output:  ${res.outputCmd}\n`;
              + `shell:   ${res.outputShell}\n`;
            resolve({
              pass: res.exitCode === 0 && res.outputCmd === `${stdout}\n`,
              log: txt,
            });
          } catch (err) {
            reject(err);
          }
        });
      }
    },
  ];

  function runTests() {
    /* Create spaceholders for each test */
    const testDiv = document.getElementById('tests');
    sessionTests.forEach((t) => {
      t.elem = document.createElement('div');
      t.elem.className = 'test_well';
      const title = document.createElement('h2');
      title.textContent = t.name;
      t.elem.appendChild(title);
      testDiv.appendChild(t.elem);
    });

    /* Run each test */
    sessionTests.forEach((t) => {
      const showTestResult = (pass, log) => {
        const result = document.createElement('h3');
        result.className = pass ? 'test_pass' : 'test_fail';
        result.textContent = pass ? 'Pass' : 'Fail';

        const output = document.createElement('pre');
        output.textContent = log;

        t.elem.appendChild(result);
        t.elem.appendChild(output);
      }

      t.run()
        .then(({pass, log}) => showTestResult(pass, log))
        .catch((err) => showTestResult(false, err));
    });
  };

  const termGeometry = {width: 80, height: 24};
  const term = new Term({
    cols: termGeometry.width, rows: termGeometry.height,
    scrollback: 10000, fontSize: 12 });

  function termHandler(str) {
    for (const c of str)
      LupBookVM.Core.consoleQueue(c.charCodeAt(0));
  };

  window.onload = (e) => {
    term.open(document.getElementById('term_container'));

    term.write("Loading VM...\r\n");
    term.setKeyHandler(termHandler);

    LupBookVM.Client.boot({
      consoleWriteDebug: (str) => term.write(str),
      consoleGeometryDebug: () => {
        const [w, h] = term.getSize();
        return { width : w, height : h};
      }
    })
      .then(() => {
        console.log('VM Init complete!');
        return LupBookVM.Session.init();
      })
      .then(() => {
        runTests();
      })
      .catch((err) => console.log('VM Error: ' + err))
  };
</script>
